import pygame,math,sys,random,os.path
from pygame.locals import*
pygame.init()
screen=pygame.display.set_mode((1280,640))
pygame.display.set_caption('Lawn Defender')
icona=pygame.image.load("icona.bmp").convert()
icona.set_colorkey((255,255,255))
pygame.display.set_icon(icona)
clock=pygame.time.Clock()
pygame.mouse.set_visible(False)
animals=pygame.sprite.Group()
moles=pygame.sprite.Group()
pidgeons=pygame.sprite.Group()
cats=pygame.sprite.Group()
neighbourgroup=pygame.sprite.GroupSingle()
p=0
shot=0
sound=1
def load_image(file, transparent):
    "lcarica immagine"
    file=os.path.join(file)
    try:
        surface = pygame.image.load(file)
    except pygame.error:
        raise SystemExit, 'non carica"%s" %s'%(file, pygame.get_error())
    if transparent:
        corner = surface.get_at((0, 0))
        surface.set_colorkey(transparent, RLEACCEL)
    return surface.convert()
def load_sound(file):
    global sound
    file=os.path.join(file)
    try:
        suono=pygame.mixer.Sound(file)
    except pygame.error:
        sound=0
        suono=0
        print "Sorry no audio."
    return     suono
def load_audio(file):
    global sound
    file=os.path.join(file)
    try:
        suono=pygame.mixer.music.load(file)
    except pygame.error:
        sound=0
        suono=0
        print "Sorry no audio."
    return     suono
class actor(pygame.sprite.Sprite):
    def __init__(self,immagine,life,x,y,direction,speed):
        pygame.sprite.Sprite.__init__(self)
        self.image=load_image(immagine,(255,255,255))
        self.x=x
        self.y=y
        self.direction=direction
        self.rect=self.image.get_rect(topleft=(self.x,self.y))
        self.speed=speed
    def move(self,direction):
        self.x=self.x+self.speed*self.direction
        self.rect= self.image.get_rect(topleft=(self.x,self.y))
        if self.x<=0 or self.x>=1280:
            self.direction=self.direction*-1
class gun(pygame.sprite.Sprite):
    def __init__(self,immagine1,immagine2,immagine3,immaginetar,immagineexp,maxshots):
        pygame.sprite.Sprite.__init__(self)
        self.img1=load_image(immagine1,(255,255,255))
        self.img2=load_image(immagine2,(255,255,255))
        self.img3=load_image(immagine3,(255,255,255))
        self.image=load_image(immaginetar,(255,255,255))
        self.imageexp=load_image(immagineexp,(255,255,255))
        self.img=self.img1
        self.maxshots=2
        self.curshots=0
        self.x=640
        self.y=320
        self.score=0
        self.level=1
        self.animalsk=0
        self.bang=0.0
        self.ouch=0
        self.precision=0
        self.live=1
        self.animalsleft=self.level*7-self.animalsk
        a=open("record.txt","r")
        self.rec=a.read()
        self.reco=str(self.rec)
        self.record=int(self.reco)
        a.close()
        self.punteggio=0
        self.rect=self.image.get_rect(topleft=(self.x,self.y))
    def reammo(self):
        self.curshots=0
    def move(self):
        self.x,self.y=pygame.mouse.get_pos()
        self.rect=self.image.get_rect(topleft=(self.x,self.y))
        self.rect.center=(self.x,self.y)
        if self.x<426:
            self.img=self.img2
        elif self.x>=426 and self.x<=852:
            self.img=self.img3
        elif self.img>852:
            self.img=self.img1
    def shoot(self):
        self.curshots=self.curshots+1
        self.bang=self.bang+1
        self.precision=(self.ouch/self.bang)*100
        self.animalsleft=self.level*7-self.animalsk
        for i in animals:
                    if i.rect.collidepoint(self.x,self.y):
                     self.ouch=self.ouch+1   
                     if i.tipo=="mole":
                      if not i.hidden:    
                       self.score=self.score+100
                       self.animalsk=self.animalsk+1
                       i.kill()
                     else:
                       self.score=self.score+100
                       self.animalsk=self.animalsk+1
                       i.kill()
                       if i.tipo=="neighbour":
                           lawn.neighbour=1
    def scrive(self):
            self.punti="SCORE: "+(str(self.score))+" PRECISION: "+(str(self.precision))+" RECORD:"+self.reco+" LEVEL:"+(str(self.level))+" ANIMALS LEFT:"+(str(self.animalsleft))
            self.t = pygame.font.Font(None, 18)
            self.punteggio=self.t.render(self.punti,1,(255,255, 0),(255, 0, 0))
            self.sr=self.punteggio.get_rect(topleft=(0,0))
            self.sr.width=10000                             
class pidgcat(actor):
       def __init__(self,immagine,image2,life,x,y,direction,speed):
             actor.__init__(self,immagine,life,x,y,direction,speed)
             self.img=self.image
             self.img2= load_image(image2,(255,255,255))
             self.p=1
             self.tipo="an"
             if self.direction==-1:
                        self.image=self.image=pygame.transform.flip(self.image,True,False)
       def muove(self):
              self.move(self.direction)
              self.p=self.p+1
              if self.p%4==0:
                     self.image=self.img2
              else:
                    self.image=self.img
              if self.direction==-1:
                        self.image=self.image=pygame.transform.flip(self.image,True,False)      
class molenei(actor):
       def __init__(self,immagine,image2,life,x,y,direction,speed,tipo):
             actor.__init__(self,immagine,life,x,y,direction,speed)
             self.tipo=tipo    
             if self.tipo=="mole":
                    self.img2= load_image(image2,(255,255,255))
                    self.img=self.image
                    self.hidden=0
                    if self.direction==-1:
                        self.image=self.image=pygame.transform.flip(self.image,True,False)
       def hide(self):
               if self.tipo=="mole":     
                self.image=self.img2
                self.hidden=1
       def show(self):
              if self.tipo=="mole":     
                self.image=self.img
                self.hidden=0
                if self.direction==-1:
                        self.image=self.image=pygame.transform.flip(self.image,True,False)
class level():
       def __init__(self,background,gameover,tende,animalsn,molesn,pidgeonsn,catsn,neighbour):
                    self.bg=load_image(background,(255,255,255))
                    self.end=load_image(gameover,(255,255,255))
                    self.tende=load_image(tende,(255,255,255))
                    self.animalsn=animalsn
                    self.molesn=molesn
                    self.pidgeonsn=pidgeonsn
                    self.catsn=catsn
                    self.neighbour=neighbour
       def new(self,animalsn,molesn,pidgeonsn,catsn,neighbour):
                    self.animalsn=animalsn
                    self.molesn=molesn
                    self.pidgeonsn=pidgeonsn
                    self.catsn=catsn
                    self.neighbour=neighbour
       def levelup(self):
           self.animalsn+=3
           self.molesn+=1
           self.pidgeonsn+=1
           self.catsn+=1
           shotgun.level+=1
       def levelra(self):
           shotgun.level+=1
           self.animalsn+=1
           self.pidgeonsn=random.randint(0,self.animalsn-1)
           self.molesn=self.animalsn-self.pidgeonsn-2
           self.catsn=self.animalsn-self.pidgeonsn-self.molesn-random.choice([0,1])
           if self.animalsn-self.catsn-self.molesn-self.pidgeonsn==0:
               self.neighbour=1
           else:
               self.neighbour=0
def new():
    shotgun.live=1
    shotgun.score=0
    shotgun.level=1
    shotgun.animalsleft=shotgun.level*7
    shotgun.animalsk=0
    shotgun.x=640
    shotgun.y=320
    shotgun.rect=shotgun.image.get_rect(topleft=(shotgun.x,shotgun.y))
    lawn.animalsn=6
    lawn.molesn=2
    lawn.pidgeonsn=2
    lawn.catsn=1
    lawn.neighbour=1
    for i in animals.sprites():
        i.kill()
shotgun=gun("doppietta_01.png","doppietta_02.png","doppietta_03.png", "target.png","explosion.bmp",2)
lawn=level("anime.png","game over.png","tende.png",6,2,2,1,1)
lev=pygame.event.Event(25)
pygame.time.set_timer(25,20000)
sparo=load_sound("shot.wav")
noam=load_sound("no ammo.wav")
rec=load_sound("rec.wav")
pige=load_sound("pige.wav")
man=load_sound("man.wav")
cat=load_sound("cat.wav")
back=load_audio("town.mp3")
if sound:
    pygame.mixer.music.play(-1)
while 1:
      clock.tick(25)
      if p==0 and shotgun.live==1:
        for event in pygame.event.get():
          if event.type == pygame.QUIT:
           pygame.quit()   
           sys.exit(0)
          elif event.type == MOUSEBUTTONDOWN:
                    if event.button==1 and shotgun.curshots<shotgun.maxshots:
                      if sound==1:
                          sparo.play(0)
                      shotgun.shoot()
                      shot=1
                    elif event.button==1 and sound==1:
                       noam.play(0)
                    if event.button==3:
                      if sound==1:
                       rec.play(0)
                      shotgun.reammo()
          elif event.type == KEYDOWN:
                    if event.key==K_p:
                     if p==0:
                       p=1
          elif event.type==25:
              if shotgun.animalsk>=shotgun.level*7:
                  lawn.levelup()
                  shotgun.animalsk=0
              elif shotgun.animalsk<shotgun.level*7:
                  shotgun.live=0
        if len(animals.sprites())<lawn.animalsn:
                    if len(moles.sprites())<lawn.molesn:
                      a=molenei("talpa_02.png","talpa 01.png",1,random.randint(200,1000),random.randint(300,500),random.choice([-1,1]),0,"mole")  
                      moles.add(a)
                      animals.add(a)
                    if len(pidgeons.sprites())<lawn.pidgeonsn:
                      b=pidgcat("piccione 01.png","piccione_02.png",1,random.randint(200,1000),random.randint(10,280),random.choice([-1,1]),10)  
                      pidgeons.add(b)
                      animals.add(b)
                      pige.play(0)
                    if len(cats.sprites())<lawn.catsn:
                      c=pidgcat("miao 01.png","miao_02.png",1,random.randint(200,1000),random.randint(190,500),random.choice([-1,1]),10)  
                      cats.add(c)
                      animals.add(c)
                      cat.play(0)
                    if lawn.neighbour==1:
                      d= molenei("omino.png",0,1,random.randint(200,1000),116,random.choice([-1,1]),0,"neighbour") 
                      animals.add(d)
                      neighbourgroup.add(d)
                      lawn.neighbour=0
                      man.play(0)
        for i in pidgeons.sprites()+cats.sprites():
                                  i.muove()
        for i in moles.sprites():
          if not int(random.random() * 15):
                   if not i.hidden:
                                  i.hide()
                   elif i.hidden:
                                  i.show()
        shotgun.move()                              
        screen.blit(lawn.bg,(0,0))
        screen.blit(shotgun.img,(498,502))                                               
        cats.draw(screen)
        moles.draw(screen)
        pidgeons.draw(screen)
        animals.draw(screen)
        neighbourgroup.draw(screen)
        shotgun.scrive()
        if shot==1:
           screen.blit(shotgun.imageexp,(shotgun.x,shotgun.y))
        screen.blit(shotgun.img,(498,502))   
        screen.blit(lawn.tende,(0,0))   
        screen.blit(shotgun.image,(shotgun.x-75,shotgun.y-75))
        screen.blit(shotgun.punteggio,(0,0))  
        pygame.display.update()
        shot=0
      if p==1 and shotgun.live==1:  
        for event in pygame.event.get():
          if event.type == pygame.QUIT:
           sys.exit()
          elif event.type == KEYDOWN:
                    if event.key==K_p:
                       p=0
      if   shotgun.live==0:
          pygame.mouse.set_visible(True)
          for event in pygame.event.get():
           if event.type == pygame.QUIT:
             pygame.quit()  
             sys.exit(0)
           elif event.type == KEYDOWN:
                    if event.key==K_n:
                       new()
                       pygame.mouse.set_visible(False)
          screen.blit(lawn.end,(200,400))
          if shotgun.score>shotgun.record:
            b=open("record.txt","w")   
            d=str(shotgun.score)
            b.write(d)
            b.close()
            shotgun.reco=str(shotgun.score)
          screen.blit(shotgun.punteggio,(0,0))
          pygame.display.update()
